workflow:
  rules:
    # use premium runners when we're running in sdc-suite
    - if: $CI_PROJECT_ROOT_NAMESPACE == "sdc-suite"
      variables:
        LINUX_RUNNER_TAG: "saas-linux-xlarge-amd64"
        # there are only medium runners for windows
        WINDOWS_RUNNER_TAG: "saas-windows-medium-amd64"
    # use the biggest free runner when running in a fork
    - if: $CI_PROJECT_ROOT_NAMESPACE != "sdc-suite"
      variables:
        LINUX_RUNNER_TAG: "saas-linux-medium-amd64"
        WINDOWS_RUNNER_TAG: "saas-windows-medium-amd64"
    # merge request pipelines
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
    # on new tag
    - if: $CI_COMMIT_TAG
    # on new commit
    - if: $CI_COMMIT_SHA

stages:
  - build

.linux_template:
  image: archlinux/archlinux:latest
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
    # disallow warnings in ci
    RUSTFLAGS: -D warnings
  tags:
    - $LINUX_RUNNER_TAG
  before_script:
    - pacman -Syu --noconfirm rust base-devel cmake protobuf git
    - cargo install cargo-deny cargo-audit

.windows_template:
  tags:
    - $WINDOWS_RUNNER_TAG
  script:
    - choco install rust-ms protoc git strawberryperl -y
    - Import-Module $env:ChocolateyInstall\helpers\chocolateyProfile.psm1
    - refreshenv

.test-windows-openssl:
  extends: .windows_template
  script:
    - !reference [.windows_template, script]
    - $env:RUST_LOG = 'info'
    - cargo test --profile dev-ci
    - cargo test -p dpws --no-default-features --features dpws/tls_openssl --profile dev-ci


lint-code:
  extends: .linux_template
  stage: build
  script:
    # lint all features, examples and tests
    - cargo clippy --all-targets --all-features -- -D warnings
    # lint openssl flag enabled
    - cargo clippy --all-targets --no-default-features --features test-utilities,dpws/tls_openssl -- -D warnings

check-fmt:
  extends: .linux_template
  stage: build
  script:
    - cargo fmt --all -- --check

deny-check:
  extends: .linux_template
  stage: build
  script:
    - cargo deny check

audit-check:
  extends: .linux_template
  stage: build
  script:
    - cargo audit

run-test-linux-dpws-openssl:
  extends: .linux_template
  stage: build
  script:
    - RUST_LOG=info cargo test -p dpws --no-default-features --features dpws/tls_openssl --profile dev-ci

# default test setup covering all cases except openssl dpws
run-test-linux:
  extends: .linux_template
  stage: build
  script:
    - cargo test --no-run --profile dev
    - RUST_LOG=info cargo test --profile dev

run-test-windows:
  extends: .test-windows-openssl
  stage: build
  rules:
    - if: $CI_COMMIT_REF_NAME == "main"
      allow_failure: false
    # windows builds are not mandatory for a merge right now
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      allow_failure: true
